<Cfscript>

//<!--- CREATE THE SOAP OBJECT --->
vr = createObject("webservice", "https://api.verticalresponse.com/wsdl/1.0/VRAPI.wsdl");

//<!--- LOGIN --->
WriteOutput("<p><b>Logging into VR...</b></p>");
vr_loginarray = StructNew();
StructInsert(vr_loginarray, "username", "allen@verticalresponse.com");
StructInsert(vr_loginarray, "password", "539d8b8f");
StructInsert(vr_loginarray, "session_duration_minutes", "2");
session_id = vr.login(vr_loginarray);
WriteOutput("<p><b>Session Id: " & session_id & "</b></p>");


//<!---   creating the list --->
vr_createListArgs = StructNew();
cfn_null[1] = "NULL";
name = "testing: " &  TimeFormat(Now(), "hh:mm:sstt");
StructInsert(vr_createListArgs, "session_id", session_id);
StructInsert(vr_createListArgs, "name", name);
StructInsert(vr_createListArgs, "type", "email");
StructInsert(vr_createListArgs, "custom_field_names", cfn_null);

list_id = vr.createList(vr_createListArgs);
WriteOutput("<p><b>Created list: " & list_id & "</b></p>");


//<!---   addList Member --->

NVPair_email = StructNew();
StructInsert(NVPair_email, "name", "email_address");
StructInsert(NVPair_email, "value", ""); // enter email address value


NVPair_fn = StructNew();
StructInsert(NVPair_fn, "name", "First_Name");
StructInsert(NVPair_fn, "value", ""); // enter First Name value

NVPair_ln = StructNew();
StructInsert(NVPair_ln, "name", "Last_Name");
StructInsert(NVPair_ln, "value", ""); // enter Last Name value

//<!---   creating the member_data --->
member_data[1] = NVPair_email;
member_data[2] = NVPair_fn;
member_data[3] = NVPair_ln;

list_member = StructNew();
StructInsert(list_member, "list_id", list_id);
StructInsert(list_member, "member_data", member_data);

addListMemberArgs = StructNew();
StructInsert(addListMemberArgs, "session_id", session_id);
StructInsert(addListMemberArgs, "list_member", list_member);                        

addMemberOut = vr.addListMember(addListMemberArgs);
WriteOutput("<p><b>added member to list...</b></p>");


//<!---   Creating Campaign Data --->
html = "<H1>Hello, CF World</h1>pretty original, huh?";
text = "Hello World!\nThe Text version";
subject = "Testing CF API code";
name_camp = "List : " &  TimeFormat(Now(), "hh:mm:sstt");
email = "allen@verticalresponse.com";

NVPair_html = StructNew();
StructInsert(NVPair_html, "type", "freeform_html");
StructInsert(NVPair_html, "copy", html);

NVPair_text = StructNew();
StructInsert(NVPair_text, "type", "freeform_text");
StructInsert(NVPair_text, "copy", text);

NVPair_subject = StructNew();
StructInsert(NVPair_subject, "type", "subject");
StructInsert(NVPair_subject, "copy", subject);

NVPair_unsub = StructNew();
StructInsert(NVPair_unsub, "type", "unsub_message");
StructInsert(NVPair_unsub, "copy", "You requested these emails, now you want to leave? If so");

contents[1] = NVPair_html;
contents[2] = NVPair_text;
contents[3] = NVPair_subject;
contents[4] = NVPair_unsub;

email_campaign = StructNew();
StructInsert(email_campaign, "name", name_camp);
StructInsert(email_campaign, "type", "freeform");
StructInsert(email_campaign, "from_label", "CF_NL");
StructInsert(email_campaign, "support_email", "api-support@verticalresponse.com");
StructInsert(email_campaign, "send_friend", 1);
StructInsert(email_campaign, "redirect_url", "http://www.verticalresponse.com");
StructInsert(email_campaign, "contents", contents);

createEmailCampaignArgs = StructNew();
StructInsert(createEmailCampaignArgs, "session_id", session_id);
StructInsert(createEmailCampaignArgs, "email_campaign", email_campaign);

campaign_id = vr.createEmailCampaign(createEmailCampaignArgs);
WriteOutput("<p><b>added email campaign...</b></p>");


//<!---  sets the list for the campaign --->

list_ids[1] = list_id;
setCampaignListArgs = StructNew();
StructInsert(setCampaignListArgs, "session_id", session_id);
StructInsert(setCampaignListArgs, "campaign_id", campaign_id);
StructInsert(setCampaignListArgs, "list_ids", list_ids);

result_scl = vr.setCampaignLists(setCampaignListArgs);
WriteOutput("<p><b>set list to campaign...</b></p>");


//<!---   sending test --->

NVPairs_rec = StructNew();
StructInsert(NVPairs_rec, "name", "email_address");
StructInsert(NVPairs_rec, "value", email);
recipient[1] = NVPairs_rec;
recipients[1] = recipient;

sendEmailCampaignTestArgs = StructNew();
StructInsert(sendEmailCampaignTestArgs, "session_id", session_id);
StructInsert(sendEmailCampaignTestArgs, "campaign_id", campaign_id);
StructInsert(sendEmailCampaignTestArgs, "recipients", recipients);
results_secta = vr.sendEmailCampaignTest(sendEmailCampaignTestArgs);
WriteOutput("<p><b>sent test message...</b></p>");

//<!---   launching campaign  --->

launchEmailCampaignArgs = StructNew();
StructInsert(launchEmailCampaignArgs, "session_id", session_id);
StructInsert(launchEmailCampaignArgs, "campaign_id", campaign_id);

results_lec = vr.launchEmailCampaign(launchEmailCampaignArgs);
WriteOutput("<p><b>launched campaign...</b></p>");
WriteOutput("<p><b>complete...</b></p>");
</cfscript>


<cffunction name= "CFDUMP" returntype="boolean" output="yes">
  <cfargument name="value" type="any" default="nothing to output">
  <CFDUMP var="#arguments.value#">
  <cfoutput><p></cfoutput>
  <cfreturn true>       
</cffunction>










